#include "greeter.h"

#include <stdio.h>
#include <cuda_runtime_api.h>

/*
 * A simple introduction to programming in CUDA. This program prints "Hello
 * World from GPU! from 10 CUDA threads running on the GPU.
 */

__global__ void helloFromGPU() {
    printf("Hello World from GPU thread %d!\n", threadIdx);
}

int main(int argc, char** argv) {


    helloFromGPU<<< 1, 10 >>>();
    greet(std::string("Pinco"));

    // explicitly destroy and clean up all resources associated with the current device in the current process.
    //cudaDeviceReset(); // CUDA functions are async... the program would terminate before CUDA kernel prints
    // Alternative to cudaDeviceReset:
    cudaDeviceSynchronize();
    return 0;
}


